<!DOCTYPE html>
<html lang="es">
<head>
  <?php require_once "./url.php" ?>

  <!-- Metadata & Essential styles and scripts -->
  <?php require_once "./headEssential.php" ?>
  <?php require_once "./gen_keys.php"; ?>

</head>
<body>

  <!-- Header -->
  <?php require_once "./header.php" ?>

  <!-- Navbar -->
  <?php require_once "./navbar.php" ?>

  <!-- Main -->
  <main class="container">
    <div id="operation">
      <ul id="tabs-operation" class="nav nav-tabs mt-6" data-tabs="tabs">
        <li class="nav-item">
          <a class="nav-link" href="<?php returnURL(); ?>">Firmar con token</a>
        </li>
        <li>
          <a class="nav-link active" href="<?php returnURL(); ?>/php/sign.php">Firmar con .p12</a>
        </li>
        <li>
          <a class="nav-link" href="<?php returnURL(); ?>/">Verificar</a>
        </li>
      </ul>

      <div id="operation-tab-content" class="tab-content py-4">
        <input id="pubkey" type="hidden" value=" <?php echo $_SESSION['public_key_pem'] ?>">
        <section class="container-fluid">
          <div class="row">
            <div class="col-12 px-0">
              <h2 class="text-center py-3 font-weight-bold text-dark">
                Firmar Electrónicamente <span class="text-primary">PKCS12</span>
              </h2>
            </div>
          </div>

          <div class="row">
            <div class="col-10 offset-1 col-md-8 offset-md-2 pt-4">
              <form id="form-sign" action="./run_script.php" method="POST" enctype="multipart/form-data">

                <div class="input-group pb-3">
                  <div class="custom-file">
                    <input id="pdf" class="custom-file-input" type="file" name="pdf" accept=".pdf" required
                           tabindex="1" />
                    <label class="custom-file-label" for="pdf">Seleccionar PDF</label>
                  </div>
                </div>

                <div class="input-group pb-3">
                  <div class="custom-file">
                    <input id="pkcs12" class="custom-file-input" type="file" name="pkcs12" accept=".p12" required
                           tabindex="2" />
                    <label class="custom-file-label" for="pkcs12">Seleccionar certificado PKCS12</label>
                  </div>
                </div>

                <div class="form-group">
                  <input id="phasepass" class="form-control" type="password" aria-describedby="passHelp"
                         required tabindex="3" placeholder="Contraseña del certificado" />
                  <small id="passHelp" class="form-text text-muted">Esta contraseña no será guardada en el servidor.</small>
                  <input id="password" name="password" type="hidden" />
                </div>

                <div class="form-group text-center">
                  <input id="sign-button" class="btn btn-primary btn-block" name="submit" type="submit" value="Firmar"
                         tabindex="4" />
                </div>

              </form>
            </div>
          </div>

        </section>
      </div>
    </div>
  </main>

  <!-- Footer -->
  <?php require_once "./footer.php" ?>

  <script src="../js/jsencrypt.min.js"></script>
  <script>
    (function() {
      /**
       * Función para imprimir los nombres en los label de los input[type=file]
       */
      var files, fileLabel, signButton, signValidation, formSign;

      formSign = document.getElementById('form-sign');
      files = document.querySelectorAll('.custom-file-input');
      fileLabel = document.querySelectorAll('.custom-file-input ~ .custom-file-label');
      signButton = document.getElementById('sign-button');
      signValidation = [2, 2];

      function validateExtension(name, ext){
        let buscarElemento = name.indexOf(ext);
        return buscarElemento;
      }

      for (var i = 0; i <= files.length -1; i++) {
        files[i].addEventListener('change', function() {
          let backslack = this.value.lastIndexOf("\\") + 1;
          let namePDF = this.value.slice(backslack, this.value.length);
          this.nextElementSibling.innerText = namePDF;
        });
      }

      // Validación que el primer input sea un pdf
      files[0].addEventListener('change', function() {
        let backslack = this.value.lastIndexOf("\\") + 1;
        let namePDF = this.value.slice(backslack, this.value.length);
        let validation = validateExtension(namePDF, "pdf");

        if (validation == -1){
          this.nextElementSibling.classList.add("border-danger");
          this.nextElementSibling.classList.add("text-danger");
          this.nextElementSibling.innerText = namePDF + " no es un archivo PDF";
          signValidation[0] = 1;
        } else {
          this.nextElementSibling.classList.remove("border-danger");
          this.nextElementSibling.classList.remove("text-danger");
          signValidation[0] = 0;
        }
      });

      files[1].addEventListener('change', function() {
        let backslack = this.value.lastIndexOf("\\") + 1;
        let namePDF = this.value.slice(backslack, this.value.length);
        let validation = validateExtension(namePDF, "p12");

        if (validation == -1){
          this.nextElementSibling.classList.add("border-danger");
          this.nextElementSibling.classList.add("text-danger");
          signValidation[1] = 1;

          this.nextElementSibling.innerText = namePDF + " no es un archivo p12";
        } else {
          this.nextElementSibling.classList.remove("border-danger");
          this.nextElementSibling.classList.remove("text-danger");
          signValidation[1] = 0;
        }

      });
      // Valida que los
      formSign.addEventListener('submit', function(event){
        if (signValidation[0] != 0 || signValidation[1] != 0){
          event.preventDefault();
        }
      });

    })();

    (function() {
    /**
     * Función para encriptar la frase de paso
     */
      document.getElementById('phasepass').addEventListener('change', function() {
        var encrypt = new JSEncrypt();
        encrypt.setPublicKey(document.getElementById("pubkey").value);
        document.getElementById("password").value = encrypt.encrypt(this.value);
      });
    })();

  </script>
</body>
</html>